::routine addClick public
  slotDir=arg(arg())  
/* @get(clicker ok textField startTime sTimeText new clickerCount) */
  
  clickNumber = clickerCount~text
  addedClickNumber = clickNumber + 1
  clickerCount~text= addedClickNumber          -- set text property
  say "Button clicked: " addedClickNumber
  if (addedClickNumber = 1) then do 
	startTime~text = TIME('L')
  end
  if (addedClickNumber = 20) then do 
	  startTimeS = startTime~text
	  endTime = TIME('L')
	  parse var startTimeS sH ":" sM ":" sS 
	  parse var endTime eH ":" eM ":" eS 
	  secondsNeeded = (eH - sH) * 3600 + (eM - sM) * 60 + (eS - sS)
	  say secondsNeeded startTimeS endTime
	  clickerCount~text = secondsNeeded
	  clicker~visible = .false
	  ok~visible = .true
	  textField~visible = .true
	  startTime~visible = .false
	  sTimeText~visible = .false
	  new~visible = .true
	  clickerCount = .false
 end
 
 ::routine startNewGame public
 slotDir=arg(arg())  
  /* @get(clicker ok textField startTime sTimeText new clickerCount) */
  
		startTime~text = ""
		clickerCount~text = 0
		
 	  clicker~visible = .true
	  ok~visible = .false
	  textField~visible = .false
	  startTime~visible = .true
	  sTimeText~visible = .true
	  new~visible = .false
	  clickerCount = .true
	  
::routine openCalc public
   	/* @get(clicker ok textField startTime sTimeText new clickerCount) */
   .logClicks~processCalc(textField~text, clickerCount~text)
   .logClicks~wait
   
   
   clickerCount~text = 0
	startTime~text = ""
	clickerCount~text = 0
		
 	clicker~visible = .true
	  ok~visible = .false
	  textField~visible = .false
	  startTime~visible = .true
	  sTimeText~visible = .true
	  new~visible = .false
	  clickerCount = .true
	
   exit

	
::requires UNO.CLS -- get UNO support
  
  
::routine logClicks
   /* Class to log and maintain the clicks, makes sure that AOO/LO ODS file gets
      processed in a thread that is different from the JavaFX Application thread
      in method processCalc.

      All attributes and methods are at the class level such that they can be
      directly accessed from any part of Rexx.
   */
::class     logClicks
::attribute bWait       class -- control attribute
::attribute logArray    class
::attribute player class
::attribute points class
::method    init        class
   expose bWait logArray
   bWait=.false               -- initialize control attribute
   self~logClear              -- create and assign a new array

::method    wait        class
   expose bWait
   guard on when bWait=.false -- block until bWait turns .false

::method    log         class
   expose logArray
   use arg dt=.nil
   if dt=.nil then dt=.DateTime~new -- make sure we have a date and time
   logArray~append(dt)
   return dt

::method    logClear    class
   expose logArray
   logArray=.array~new


::method    processCalc class -- interacting with OpenOffice outside of JavaFX Application thread!
   expose   bWait logArray players points
   use arg players, points
   bWait=.true                -- from now on any invocation of the "wait" method will block !

   -- return to caller, then create a new separate thread to execute the remaining code below on it!
   reply

   storeUrl = directory()"/points.ods"
   uri = uno.convertToUrl(storeUrl)
   xDesktop=uno.createDesktop() -- bootstrap & get access to XDesktop
   xcl=xDesktop~XComponentLoader -- get XComponentLoader interface
   doc=xcl~loadComponentFromURL(uri,"_blank",0,.uno~noProps)
   xSheets=doc~XSpreadSheetDocument~getSheets~XIndexAccess
   xSheet =xSheets~getByIndex(0)~XSpreadSheet -- get first spreadsheet

   
   
i = 1
do forever
content = xSheet~getCellByPosition(0,i)~getFormula
if content = "" then do
	nameCell = xSheet~getCellByPosition(0,i)
	nameCell~setFormula(players)
	secondsCell = xSheet~getCellByPosition(1,i)
	secondsCell~setFormula(points)
	leave
	end
i = i + 1

props=xSheet~XCellRange~getCellRangeByName("A1:B1")~XPropertySet
fontWeight=.uno_constants~new("com.sun.star.awt.FontWeight")
props~setPropertyValue("CharWeight", fontWeight~bold)
end

   doc~XStorable~storeAsURL(uri, .UNO~noProps)  -- save document
   --doc~dispose          -- close and remove document
   bWait=.false         -- release control attribute, releases blocked messages

  

  
::requires UNO.CLS -- get UNO support
  
  
